#ifndef __DESCRIPTOR_SFB_H
#define __DESCRIPTOR_SFB_H


#include "tipos.h"

/* struct DescriptorSFB			      				*/
/*									*/
/*	Estructura de descripcin del sistema de ficheros bsico	*/
/*  									*/


struct DescriptorSFB
{

  /* Tamaos. Datos tomados del superbloque del disco */

  WORD tam_bloque_fisico;		/* tamao de bloque fsico */
  DWORD num_bloques_fisicos;		/* nmero de bloques fsicos */

  /* Orgenes de las reas en disco (medidos en bloques fsicos) */
  /* Datos tomados del superbloque del disco */

  WORD tam_bloque_datos;	/* tamao de bloque de datos
				   (medido en bloques fsicos) */
  WORD num_BFB;		/* numero de BFBs */

  DWORD org_BFB;	/* origen de los bloques de ficheros bsicos */
  DWORD org_datos;	/* origen de los bloques de datos */

  DWORD primer_bloque_libre;
  DWORD ultimo_bloque_datos;

  /* Tamaos y cantidades calculados al montar un SFB */

  WORD BFBs_por_BF;	/* bloques de fichero en un bloque fsico */
  DWORD nbloques_BFB;	/* nmero de bloques fsicos ocupados por BFBs */
  DWORD nbloques_datos;	/* nmero de bloques de datos */

  /* Control de montaje */

  int montado;		/* 0 si no hay sistema montado */

};


/* Variable global con la descripcin del sistema de ficheros */

extern struct DescriptorSFB DESC;


/* Rutinas para transferir el superbloque al disco */

int LeeSuperbloque (struct DescriptorSFB*);
int EscribeSuperbloque (const struct DescriptorSFB*);


#endif
