/************************************************************************/
/*									*/
/*	ERRORES.C							*/
/*	=========							*/
/*									*/
/*	Implementacin de un sistema de ficheros muy simple,		*/
/*	para realizar prcticas de diseo de sistemas operativos.	*/
/*								 	*/
/*	Este mdulo implementa una subrutina para imprimir mensajes  	*/
/*	de error.							*/
/*						      			*/
/************************************************************************/ 


#include "errores.h"
#include <stdio.h>

/* Tabla de mensajes de error */

static
const char* tabla_mensajes_error[] =
{
  "***", /* ERR_INICIO_ERRORES */
  "espacio insuficiente", /* ERR_ESPACIO */	
  "parmetro no vlido", /* ERR_PARAMETRO */	
  "error al operar con el disco fsico", /* ERR_DISCO */	
  "formato incorrecto del sistema de ficheros", /* ERR_FORMATO */	
  "el sistema de ficheros est corrupto", /* ERR_CORRUPTO */	
  "el fichero no existe", /* ERR_NOEXISTE */	
  "el fichero ya existe", /* ERR_EXISTE */	
  "ya hay un sistema montado", /* ERR_MONTADO */	
  "el sistema no est montado", /* ERR_INACTIVO */	
  "el parametro esta fuera de rango", /* ERR_RANGO */	
  "el recurso estaba libre", /* ERR_LIBRE */
  "el recurso estaba ocupado", /* ERR_OCUPADO */	
  "no se tienen permisos para realizar la operacion", /* ERR_PERMISOS */      
  "el servicio no est implementado", /* ERR_IMPLEME */	
};

/* variable pblica */
enum Errores Error_SF;


/* subrutina que explica el error actual */

void MensajeError (const char* prologo)
{
  const char* mensaje;
  if (Error_SF==SIN_ERROR) mensaje="no hay error";
  if (Error_SF>ERR_INICIO_ERRORES && Error_SF<ERR_BESTIA)
    mensaje=tabla_mensajes_error[(int)Error_SF-ERR_INICIO_ERRORES];
  else mensaje="error desconocido";
  fprintf(stderr,"%s: %s (Error_SF=%d)\n",prologo,mensaje,Error_SF);
}
