#ifndef __SFBASICO_H
#define __SFBASICO_H

/************************************************************************/
/*									*/
/*	SFBASICO.H							*/
/*	==========							*/
/*									*/
/*	Interfaz con un sistema de ficheros muy simple,			*/
/*	para realizar prcticas de diseo de sistemas operativos.	*/
/*									*/
/*	Caractersticas:						*/
/*									*/
/*		- Slo un directorio raz				*/
/*		- Ficheros de tamao fijo				*/
/*		- Transferencias por bloques (no por bytes)		*/
/*		- Si se borra un fichero, los bloques ocupados		*/
/*		  no quedan disponibles					*/
/*									*/
/*	Versin 2.0b							*/
/*	                                                                */
/*	 Jos Miguel Santos, Carmelo Rubn Garca, Gabino Padrn,	*/
/*      1996-97-98							*/
/*									*/
/************************************************************************/



/* Tipos bsicos de las prcticas */

#include "tipos.h"



/****************************/
/* Servicios de este mdulo */
/****************************/



/* Formateo y montaje de discos */

int FormateaSFB ( const char* nombre_fichero, const char* args[] );

int MontaSFB ( const char* nombre_fichero, int nbloques_cache );
int DesmontaSFB (void);



/* Informacin del sistema */

WORD	TamBloqueDatos(void);
DWORD	EspacioLibre (void);
WORD	FicherosLibres (void);


/* Creacin y destruccin de ficheros */

IFB CreaFB ( const char* nombre, WORD num_bloques );
int DestruyeFB ( IFB fichero );


/* Tamao del fichero */

WORD LongitudFB ( IFB fichero );
int CambiaLongitudFB ( IFB fichero, WORD num_bloques );


/* Lectura y escritura de bloques */

int LeeBloqueFB ( IFB fichero, WORD num_bloque, void* bufer );
int EscribeBloqueFB ( IFB fichero, WORD num_bloque, const void* bufer );


/* Gestin de nombres y directorios */

IFB BuscaFB ( const char* nombre );
IFB EntradaDir ( int numero_de_orden, char* nombre );

/* Servicios aadidos por ustedes */

#include "extrasfb.h"

#endif
